<template>
  <ObModal
    ref="modal"
    title="Фильтр граничных значений"
    size="max"
    cancel-text="Закрыть"
    :is-show-controls="true"
    :is-confirm="true"
    :is-close-on-overlay="false"
    :is-submit-disabled="isOptionsDisabled"
    @submit="onSaveFilterEdges"
    @cancel="onCancelFilterEdgesModal"
  >
    <div class="scenario-modal">
      <div class="edges-filter">
        <div class="row">
          <div class="col-xs-4 edges-filter__variants">
            Вариант расчета ограничений: 

            <ObInlineSelect
              label="Не выбран"
              placeholder="Выберите"
              value-expr="type"
              :items="filterEdgesItems"
              :disabled="isOptionsDisabled"
              v-model="options.edges.type"
              @input="onChangeOptionsEdgeType"
            />
          </div>

          <div
            v-if="options.edges.type"
            class="col-xs-8"
          >
            <div class="edges-filter__values">
              Исключить предложения со ставками ниже средней на

              <ObInput
                v-model.number="options.edges.min"
                :mini="true"
                class="edges-filter__input"
                :disabled="isOptionsDisabled"
              />

              и выше средней на

              <ObInput
                v-model.number="options.edges.max"
                :mini="true"
                class="edges-filter__input"
                :disabled="isOptionsDisabled"
              />
            </div>

            <ObButton
              v-if="isShowRecalculateButton"
              :mini="true"
              label="Пересчитать"
              class="edges-filter__button"
              @click="loadData"
            />
          </div>
        </div>
      </div>

      <ObTabs
        v-model="selectedFilterEdgesTab"
        :items="filterEdgesTabs"
        @on-change-tab="onChangeFilterEdgesTab"
        class="edges-tabs"
      />

      <!-- :key is using to re-render 'noneContent' -->
      <ObTable
        ref="filter-edges-table"
        :key="`${isTableDataVisible ? 'with' : 'without'}-none-content`"
        :columns="filterEdgesColumns"
        :remote-opt="{
          method: deviationMethod,
          arguments: {
            tenderUuid,
            scenarioUuid
          },
          contentKey: 'lots'
        }"
        :functional-panel="isTableDataVisible"
        :table-layout-fixed="true"
        :show-hidden-length="true"
        :is-functional-sort="false"
        :is-functional-group="false"
        class="edges-table"
      >
        <template
          v-if="!isTableDataVisible"
          slot="noneContent"
        >
          <div class="none-content__title">
            Все предложения участвуют в расчете сценария
          </div>

          <div class="none-content__description">
            Вы можете исключить из расчетов сценария предложения
            со слишком высокими или слишком низкими ставками.
            Для этого выберите вариант расчета и настройте значения отклонений.
          </div>
        </template>

        <div
          slot="dropdownMenu"
          slot-scope="{ data }"
          class="edges-row-menu"
        >
          <ObMenuDropdown :items="getDeviationItems(data)" />
        </div>
      </ObTable>
    </div>
  </ObModal>
</template>

<script>
  import api from "@/api";
  import ObInlineSelect from "common-components/src/obComponents/obInlineSelect";
  import ObInput from "common-components/src/obComponents/obInput";
  import ObTabs from "common-components/src/obComponents/obTabs";
  import ObTable from "common-components/src/obComponents/obTable";
  import ObButton from "common-components/src/obComponents/obButton";
  import ObMenuDropdown from "common-components/src/obComponents/obMenuDropdown";
  import ScenarioModalMixin from "../mixins/scenarioModalMixin";
  import { uuid } from "vue-uuid";
  import { mapGetters } from "vuex";

  export default {
    name: "tender-scenario-filter-edges-modal",
    mixins: [
      ScenarioModalMixin
    ],
    components: {
      ObInlineSelect,
      ObInput,
      ObTabs,
      ObTable,
      ObButton,
      ObMenuDropdown
    },
    props: {
      filterEdgesItems: {
        type: Array,
        required: true
      }
    },
    data () {
      return {
        filterEdgesColumns: [],
        selectedFilterEdgesTab: {}
      }
    },
    computed: {
      ...mapGetters({
        scenario: "tendersScenario/scenario",
        scenarioParams: "tendersScenario/scenarioParams",
        initialParams: "tendersScenario/initialParams",
        isOptionsDisabled: "tendersScenario/isOptionsDisabled"
      }),
      isTableDataVisible() {
        return !!this.options.edges.type;
      },
      deviationMethod({ selectedFilterEdgesTab: { type } }) {
        if (!this.isTableDataVisible) {
          return () => ({});
        }

        switch (type) {
          case "excluded":
            return this.getTenderScenarioBoundaryValues;
          case "included":
            return this.getManuallyIncludedOffers;
          default:
            return () => ({});
        }
      },
      filterEdgesTabs() {
        return [
          {
            title: "Исключаемые по фильтру ставки",
            type: "excluded"
          },
          {
            title: "Включенные вручную ставки",
            type: "included",
            isDisabled: !this.isTableDataVisible
          }
        ]
      },
      isShowRecalculateButton({ scenarioParams, options, isOptionsDisabled }) {
        return (
          (scenarioParams.DEVIATION_PER_LOT_TO   !== options.edges.max ||
          scenarioParams.DEVIATION_PER_LOT_FROM !== options.edges.min) && !isOptionsDisabled
        )
      },
      options: {
        get () {
          return this.$store.state.tendersScenario.options
        },
        set (value) {
          this.$store.dispatch("tendersScenario/setOptions", value)
        }
      }
    },
    created() {
      this.selectedFilterEdgesTab = this.filterEdgesTabs[0];
    },
    methods: {
      onChangeFilterEdgesTab(tab) {
        this.selectedFilterEdgesTab = tab;

        this.loadData();
      },
      onSaveFilterEdges() {
        const { params } = this.scenario;

        params.INCLUDED_DEVIATIONS = this.options.includedDeviations;
        params.DEVIATION_TYPE = this.options.edges.type;
        params.DEVIATION_PER_LOT_FROM = this.options.edges.min;
        params.DEVIATION_PER_LOT_TO = this.options.edges.max;

        // Clear edges values if type is not selected
        if (!params.DEVIATION_TYPE) {
          params.DEVIATION_PER_LOT_FROM = 0;
          params.DEVIATION_PER_LOT_TO = 10;
          params.INCLUDED_DEVIATIONS = [];

          this.options.includedDeviationsItems = [];
        }

        this.close();
      },
      async onCancelFilterEdgesModal() {
        // By some reason params.INCLUDED_DEVIATIONS updates if we update
        // this.options.includedDeviations
        // so this crutch fix it
        const { params } = this.scenario;

        params.INCLUDED_DEVIATIONS = JSON.parse(this.initialParams).INCLUDED_DEVIATIONS;

        const includedDeviationsItems = await api.tendersScenarios.getTenderScenarioIncludedDeviations({
          tenderUuid: this.tenderUuid,
          scenarioUuid: this.scenarioUuid
        });

        // Crutch for unique table keys
        // uuid is a frontend generated value to escape unique keys by uuid error
        // lUuid is an original uuid
        includedDeviationsItems.lots = includedDeviationsItems.lots.map((lot) => {
          return {
            ...lot,
            lUuid: lot.uuid,
            uuid: uuid.v4()
          }
        })

        this.options.includedDeviationsItems = includedDeviationsItems.lots;
      },
      async getManuallyIncludedOffers() {
        return await this.options.includedDeviationsItems;
      },
      async getTenderScenarioBoundaryValues({ ...args }) {
        const payload = {
          settings: {
            type: this.options.edges.type,
            from: this.options.edges.min,
            to: this.options.edges.max,
            carrierUuids: this.scenarioParams.CONTRACTOR_FILTER,
            includedDeviations: this.options.includedDeviations
          }
        }

        const response = await api.tendersScenarios.postTenderScenarioBoundaryValues({ ...args, payload });

        if (response.lots?.length) {
          // Crutch for unique table keys
          // uuid is a frontend generated value to escape unique keys by uuid error
          // lUuid is an original uuid
          response.lots = response.lots.map((lot) => ({
            ...lot,
            lUuid: lot.uuid,
            uuid: uuid.v4()
          }))

          this.filterEdgesColumns = response.lots[0].headers
            .sort((a,b) => a.categoryPos - b.categoryPos || a.pos - b.pos)
            .map(header => ({
              title: header.title,
              headerHtml: () => `<div class="text-gray">${header.categoryTitle}</div>${header.title}`,
              key: header.uuid,
              isAlignRight: ['INTEGER', 'FLOAT'].includes(header.valueType),
              html: (data) => data.headers.find(h => h.uuid === header.uuid).value
            }))

          this.filterEdgesColumns.push({
            title: "Перевозчик",
            html: (data) => data.offer.participantTitle
          });

          response.lots[0].offer.headers
            .sort((a,b) => a.pos - b.pos)
            .map(header => {
              this.filterEdgesColumns.push({
                title: header.title,
                key: header.uuid,
                isAlignRight: ['INTEGER', 'FLOAT'].includes(header.valueType),
                html: (data) => {
                  let value = data.offer.headers.find(h => h.uuid === header.uuid).value || ''

                  // If value is not 'null'
                  if (value) {
                    value = Math.round(value * 100) / 100
                  }

                  return `<div class="highlighted-td"><span>${value}</span></div>`
                }
              })
            })

          this.filterEdgesColumns.push({
            title: "Средняя ставка",
            key: "averageBid",
            isAlignRight: true,
            html: ({ averageBid }) => Math.round(averageBid * 100) / 100
          });

          if (!this.isOptionsDisabled) {
            this.filterEdgesColumns.push({
              title: " ",
              slotName: "dropdownMenu",
              width: 90,
              action: true,
              sortDisable: true,
              isToggleDisabled: true,
              isAlignRight: true,
              exactWidth: '70px'
            });
          }
        }

        return response;
      },
      getDeviationItems(data) {
        return [{
          title: this.selectedFilterEdgesTab.type === "excluded" ? "Включить в распределение" : "Исключить из распределения",
          method: () => this.onSelectDeviation(data)
        }]
      },
      async onChangeOptionsEdgeType(type) {
        if (!type) {
          // Reset selected tab, because only first tab will not be disabled
          this.selectedFilterEdgesTab = this.filterEdgesTabs[0];

          return;
        }

        // Reset edges to default values if we select any DEVIATION_TYPE
        this.options.edges.min = this.scenarioParams.DEVIATION_PER_LOT_FROM = JSON.parse(this.initialParams).DEVIATION_PER_LOT_FROM;
        this.options.edges.max = this.scenarioParams.DEVIATION_PER_LOT_TO = JSON.parse(this.initialParams).DEVIATION_PER_LOT_TO;

        this.loadData();
      },
      async onSelectDeviation({ item }) {
        // "item.uuid" is a frontend generated value to escape unique keys by uuid error
        // "item.lUuid" is an original uuid

        const existingLot = this.options.includedDeviations.find(d => d.lotUuid === item.lUuid);

        switch (this.selectedFilterEdgesTab.type) {
          case "excluded":
            if (existingLot) {
              existingLot.offersUuids.push(item.offer.uuid)
            } else {
              this.options.includedDeviations.push({
                lotUuid: item.lUuid,
                offersUuids: [item.offer.uuid]
              })
            }

            this.options.includedDeviationsItems.push(item);

            break;

          case "included":
            existingLot.offersUuids = existingLot.offersUuids.filter(offerUuid => offerUuid !== item.offer.uuid);

            if (!existingLot.offersUuids.length) {
              this.options.includedDeviations = this.options.includedDeviations.filter(d => d.lotUuid !== existingLot.lotUuid)
            }

            this.options.includedDeviationsItems = this.options.includedDeviationsItems.filter((i) => {
              return i.offer.uuid !== item.offer.uuid || i.lUuid !== item.lUuid
            });

            break;
        }

        this.loadData(false);
      },
      loadData(init = true) {
        this.$nextTick(() => this.$refs["filter-edges-table"].loadData({ init }))
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .edges-filter {
    @include font-mixin(14px, 18px, 400, $color-text-base);

    margin-bottom: 20px;

    &__variants {
      height: 30px;
    }

    &__values {
      display: flex;
      align-items: center;
      justify-content: flex-end;
    }

    &__input {
      width: 100px;
      margin: 0 5px;
      position: relative;

      &::after {
        @include font-mixin(14px, 18px, 400, $gray-slate);

        content: '%';
        position: absolute;
        top: 0;
        bottom: 0;
        right: 7px;
        margin: auto;
        height: 18px;
      }
    }

    &__button {
      margin: 20px 0 0 auto;
    }
  }

  .edges-tabs {
    overflow: hidden; // To cut <ObTabs> sliding line
    margin-bottom: 20px;
  }

  .edges-table {
    border: 1px solid $lavender;
  }

  .edges-row-menu {
    display: flex; // Removed whitespace
  }

  .none-content {
    &__title {
      @include font-mixin(24px, 29px, 400, $color-grey-span, 0.4px);

      margin-bottom: 10px;
    }

    &__description {
      @include font-mixin(14px, 18px, 400, $color-text-base);

      max-width: 800px;
    }
  }

  ::v-deep {
    .highlighted-td {
      span {
        position: relative;
      }

      &::before {
        content: '';
        position: absolute;
        left: 0;
        top: 0;
        width: 100%;
        height: 100%;
        background-color: $tendersPage-scenario_modal_highlighted_td_background_before;
      }
    }

    .table-panel-inner {
      overflow: visible;
      min-height: 420px;

      th.--sticky {
        position: relative;
      }
    }
  }
</style>